SpyBara
Go Premium

resources/uploads/index.md 2026-07-10 23:02 UTC to 2026-07-12 06:58 UTC

71 added, 44 removed.

2026
Wed 15 02:58 Tue 14 06:58 Mon 13 15:59 Sun 12 06:58 Fri 10 23:02 Thu 9 20:58 Tue 7 08:02

Uploads

Create upload

post /uploads

Creates an intermediate Upload object that you can add Parts to. Currently, an Upload can accept at most 8 GB in total and expires after an hour after you create it.

Once you complete the Upload, we will create a File object that contains all the parts you uploaded. This File is usable in the rest of our platform as a regular File object.

For certain purpose values, the correct mime_type must be specified. Please refer to documentation for the supported MIME types for your use case.

For guidance on the proper filename extensions for each purpose, please follow the documentation on creating a File.

Returns the Upload object with status pending.

Body Parameters

  • bytes: number

    The number of bytes in the file you are uploading.

  • filename: string

    The name of the file to upload.

  • mime_type: string

    The MIME type of the file.

    This must fall within the supported MIME types for your file purpose. See the supported MIME types for assistants and vision.

  • purpose: "assistants" or "batch" or "fine-tune" or "vision"

    The intended purpose of the uploaded file.

    See the documentation on File purposes.

    • "assistants"

    • "batch"

    • "fine-tune"

    • "vision"

  • expires_after: optional object { anchor, seconds }

    The expiration policy for a file. By default, files with purpose=batch expire after 30 days and all other files are persisted until they are manually deleted.

    • anchor: "created_at"

      Anchor timestamp after which the expiration policy applies. Supported anchors: created_at.

      • "created_at"
    • seconds: number

      The number of seconds after the anchor time that the file will expire. Must be between 3600 (1 hour) and 2592000 (30 days).

Returns

  • Upload object { id, bytes, created_at, 6 more }

    The Upload object can accept byte chunks in the form of Parts.

    • id: string

      The Upload unique identifier, which can be referenced in API endpoints.

    • bytes: number

      The intended number of bytes to be uploaded.

    • created_at: number

      The Unix timestamp (in seconds) for when the Upload was created.

    • expires_at: number

      The Unix timestamp (in seconds) for when the Upload will expire.

    • filename: string

      The name of the file to be uploaded.

    • purpose: string

      The intended purpose of the file. Please refer here for acceptable values.

    • status: "pending" or "completed" or "cancelled" or "expired"

      The status of the Upload.

      • "pending"

      • "completed"

      • "cancelled"

      • "expired"

    • file: optional FileObject

      The File object represents a document that has been uploaded to OpenAI.

      • id: string

        The file identifier, which can be referenced in the API endpoints.

      • bytes: number

        The size of the file, in bytes.

      • created_at: number

        The Unix timestamp (in seconds) for when the file was created.

      • filename: string

        The name of the file.

      • object: "file"

        The object type, which is always file.

        • "file"
      • purpose: "assistants" or "assistants_output" or "batch" or 5 more

        The intended purpose of the file. Supported values are assistants, assistants_output, batch, batch_output, fine-tune, fine-tune-results, vision, and user_data.

        • "assistants"

        • "assistants_output"

        • "batch"

        • "batch_output"

        • "fine-tune"

        • "fine-tune-results"

        • "vision"

        • "user_data"

      • status: "uploaded" or "processed" or "error"

        Deprecated. The current status of the file, which can be either uploaded, processed, or error.

        • "uploaded"

        • "processed"

        • "error"

      • expires_at: optional number

        The Unix timestamp (in seconds) for when the file will expire.

      • status_details: optional string

        Deprecated. For details on why a fine-tuning training file failed validation, see the error field on fine_tuning.job.

    • object: optional "upload"

      The object type, which is always "upload".

      • "upload"

Example

curl https://api.openai.com/v1/uploads \
    -H 'Content-Type: application/json' \
    -H "Authorization: Bearer $OPENAI_API_KEY" \
    -d '{
          "bytes": 0,
          "filename": "filename",
          "mime_type": "mime_type",
          "purpose": "assistants"
        }'

Response

{
  "id": "id",
  "bytes": 0,
  "created_at": 0,
  "expires_at": 0,
  "filename": "filename",
  "purpose": "purpose",
  "status": "pending",
  "file": {
    "id": "id",
    "bytes": 0,
    "created_at": 0,
    "filename": "filename",
    "object": "file",
    "purpose": "assistants",
    "status": "uploaded",
    "expires_at": 0,
    "status_details": "status_details"
  },
  "object": "upload"
}

Example

curl https://api.openai.com/v1/uploads \
  -H "Authorization: Bearer $OPENAI_API_KEY" \
  -d '{
    "purpose": "fine-tune",
    "filename": "training_examples.jsonl",
    "bytes": 2147483648,
    "mime_type": "text/jsonl",
    "expires_after": {
      "anchor": "created_at",
      "seconds": 3600
    }
  }'

Response

{
  "id": "upload_abc123",
  "object": "upload",
  "bytes": 2147483648,
  "created_at": 1719184911,
  "filename": "training_examples.jsonl",
  "purpose": "fine-tune",
  "status": "pending",
  "expires_at": 1719127296
}

Complete upload

post /uploads/{upload_id}/complete

Completes the Upload.

Within the returned Upload object, there is a nested File object that is ready to use in the rest of the platform.

You can specify the order of the Parts by passing in an ordered list of the Part IDs.

The number of bytes uploaded upon completion must match the number of bytes initially specified when creating the Upload object. No Parts may be added after an Upload is completed. Returns the Upload object with status completed, including an additional file property containing the created usable File object.

Path Parameters

  • upload_id: string

Body Parameters

  • part_ids: array of string

    The ordered list of Part IDs.

  • md5: optional string

    The optional md5 checksum for the file contents to verify if the bytes uploaded matches what you expect.

Returns

  • Upload object { id, bytes, created_at, 6 more }

    The Upload object can accept byte chunks in the form of Parts.

    • id: string

      The Upload unique identifier, which can be referenced in API endpoints.

    • bytes: number

      The intended number of bytes to be uploaded.

    • created_at: number

      The Unix timestamp (in seconds) for when the Upload was created.

    • expires_at: number

      The Unix timestamp (in seconds) for when the Upload will expire.

    • filename: string

      The name of the file to be uploaded.

    • purpose: string

      The intended purpose of the file. Please refer here for acceptable values.

    • status: "pending" or "completed" or "cancelled" or "expired"

      The status of the Upload.

      • "pending"

      • "completed"

      • "cancelled"

      • "expired"

    • file: optional FileObject

      The File object represents a document that has been uploaded to OpenAI.

      • id: string

        The file identifier, which can be referenced in the API endpoints.

      • bytes: number

        The size of the file, in bytes.

      • created_at: number

        The Unix timestamp (in seconds) for when the file was created.

      • filename: string

        The name of the file.

      • object: "file"

        The object type, which is always file.

        • "file"
      • purpose: "assistants" or "assistants_output" or "batch" or 5 more

        The intended purpose of the file. Supported values are assistants, assistants_output, batch, batch_output, fine-tune, fine-tune-results, vision, and user_data.

        • "assistants"

        • "assistants_output"

        • "batch"

        • "batch_output"

        • "fine-tune"

        • "fine-tune-results"

        • "vision"

        • "user_data"

      • status: "uploaded" or "processed" or "error"

        Deprecated. The current status of the file, which can be either uploaded, processed, or error.

        • "uploaded"

        • "processed"

        • "error"

      • expires_at: optional number

        The Unix timestamp (in seconds) for when the file will expire.

      • status_details: optional string

        Deprecated. For details on why a fine-tuning training file failed validation, see the error field on fine_tuning.job.

    • object: optional "upload"

      The object type, which is always "upload".

      • "upload"

Example

curl https://api.openai.com/v1/uploads/$UPLOAD_ID/complete \
    -H 'Content-Type: application/json' \
    -H "Authorization: Bearer $OPENAI_API_KEY" \
    -d '{
          "part_ids": [
            "string"
          ]
        }'

Response

{
  "id": "id",
  "bytes": 0,
  "created_at": 0,
  "expires_at": 0,
  "filename": "filename",
  "purpose": "purpose",
  "status": "pending",
  "file": {
    "id": "id",
    "bytes": 0,
    "created_at": 0,
    "filename": "filename",
    "object": "file",
    "purpose": "assistants",
    "status": "uploaded",
    "expires_at": 0,
    "status_details": "status_details"
  },
  "object": "upload"
}

Example

curl https://api.openai.com/v1/uploads/upload_abc123/complete
  -d '{
    "part_ids": ["part_def456", "part_ghi789"]
  }'

Response

{
  "id": "upload_abc123",
  "object": "upload",
  "bytes": 2147483648,
  "created_at": 1719184911,
  "filename": "training_examples.jsonl",
  "purpose": "fine-tune",
  "status": "completed",
  "expires_at": 1719127296,
  "file": {
    "id": "file-xyz321",
    "object": "file",
    "bytes": 2147483648,
    "created_at": 1719186911,
    "expires_at": 1719127296,
    "filename": "training_examples.jsonl",
    "purpose": "fine-tune",
  }
}

Cancel upload

post /uploads/{upload_id}/cancel

Cancels the Upload. No Parts may be added after an Upload is cancelled.

Returns the Upload object with status cancelled.

Path Parameters

  • upload_id: string

Returns

  • Upload object { id, bytes, created_at, 6 more }

    The Upload object can accept byte chunks in the form of Parts.

    • id: string

      The Upload unique identifier, which can be referenced in API endpoints.

    • bytes: number

      The intended number of bytes to be uploaded.

    • created_at: number

      The Unix timestamp (in seconds) for when the Upload was created.

    • expires_at: number

      The Unix timestamp (in seconds) for when the Upload will expire.

    • filename: string

      The name of the file to be uploaded.

    • purpose: string

      The intended purpose of the file. Please refer here for acceptable values.

    • status: "pending" or "completed" or "cancelled" or "expired"

      The status of the Upload.

      • "pending"

      • "completed"

      • "cancelled"

      • "expired"

    • file: optional FileObject

      The File object represents a document that has been uploaded to OpenAI.

      • id: string

        The file identifier, which can be referenced in the API endpoints.

      • bytes: number

        The size of the file, in bytes.

      • created_at: number

        The Unix timestamp (in seconds) for when the file was created.

      • filename: string

        The name of the file.

      • object: "file"

        The object type, which is always file.

        • "file"
      • purpose: "assistants" or "assistants_output" or "batch" or 5 more

        The intended purpose of the file. Supported values are assistants, assistants_output, batch, batch_output, fine-tune, fine-tune-results, vision, and user_data.

        • "assistants"

        • "assistants_output"

        • "batch"

        • "batch_output"

        • "fine-tune"

        • "fine-tune-results"

        • "vision"

        • "user_data"

      • status: "uploaded" or "processed" or "error"

        Deprecated. The current status of the file, which can be either uploaded, processed, or error.

        • "uploaded"

        • "processed"

        • "error"

      • expires_at: optional number

        The Unix timestamp (in seconds) for when the file will expire.

      • status_details: optional string

        Deprecated. For details on why a fine-tuning training file failed validation, see the error field on fine_tuning.job.

    • object: optional "upload"

      The object type, which is always "upload".

      • "upload"

Example

curl https://api.openai.com/v1/uploads/$UPLOAD_ID/cancel \
    -X POST \
    -H "Authorization: Bearer $OPENAI_API_KEY"

Response

{
  "id": "id",
  "bytes": 0,
  "created_at": 0,
  "expires_at": 0,
  "filename": "filename",
  "purpose": "purpose",
  "status": "pending",
  "file": {
    "id": "id",
    "bytes": 0,
    "created_at": 0,
    "filename": "filename",
    "object": "file",
    "purpose": "assistants",
    "status": "uploaded",
    "expires_at": 0,
    "status_details": "status_details"
  },
  "object": "upload"
}

Example

curl https://api.openai.com/v1/uploads/upload_abc123/cancel

Response

{
  "id": "upload_abc123",
  "object": "upload",
  "bytes": 2147483648,
  "created_at": 1719184911,
  "filename": "training_examples.jsonl",
  "purpose": "fine-tune",
  "status": "cancelled",
  "expires_at": 1719127296
}

Domain Types

Upload

  • Upload object { id, bytes, created_at, 6 more }

    The Upload object can accept byte chunks in the form of Parts.

    • id: string

      The Upload unique identifier, which can be referenced in API endpoints.

    • bytes: number

      The intended number of bytes to be uploaded.

    • created_at: number

      The Unix timestamp (in seconds) for when the Upload was created.

    • expires_at: number

      The Unix timestamp (in seconds) for when the Upload will expire.

    • filename: string

      The name of the file to be uploaded.

    • purpose: string

      The intended purpose of the file. Please refer here for acceptable values.

    • status: "pending" or "completed" or "cancelled" or "expired"

      The status of the Upload.

      • "pending"

      • "completed"

      • "cancelled"

      • "expired"

    • file: optional FileObject

      The File object represents a document that has been uploaded to OpenAI.

      • id: string

        The file identifier, which can be referenced in the API endpoints.

      • bytes: number

        The size of the file, in bytes.

      • created_at: number

        The Unix timestamp (in seconds) for when the file was created.

      • filename: string

        The name of the file.

      • object: "file"

        The object type, which is always file.

        • "file"
      • purpose: "assistants" or "assistants_output" or "batch" or 5 more

        The intended purpose of the file. Supported values are assistants, assistants_output, batch, batch_output, fine-tune, fine-tune-results, vision, and user_data.

        • "assistants"

        • "assistants_output"

        • "batch"

        • "batch_output"

        • "fine-tune"

        • "fine-tune-results"

        • "vision"

        • "user_data"

      • status: "uploaded" or "processed" or "error"

        Deprecated. The current status of the file, which can be either uploaded, processed, or error.

        • "uploaded"

        • "processed"

        • "error"

      • expires_at: optional number

        The Unix timestamp (in seconds) for when the file will expire.

      • status_details: optional string

        Deprecated. For details on why a fine-tuning training file failed validation, see the error field on fine_tuning.job.

    • object: optional "upload"

      The object type, which is always "upload".

      • "upload"

Parts

Add upload part

post /uploads/{upload_id}/parts

Adds a Part to an Upload object. A Part represents a chunk of bytes from the file you are trying to upload.

Each Part can be at most 64 MB, and you can add Parts until you hit the Upload maximum of 8 GB.

It is possible to add multiple Parts in parallel. You can decide the intended order of the Parts when you complete the Upload.

Path Parameters

  • upload_id: string

Returns

  • UploadPart object { id, created_at, object, upload_id }

    The upload Part represents a chunk of bytes we can add to an Upload object.

    • id: string

      The upload Part unique identifier, which can be referenced in API endpoints.

    • created_at: number

      The Unix timestamp (in seconds) for when the Part was created.

    • object: "upload.part"

      The object type, which is always upload.part.

      • "upload.part"
    • upload_id: string

      The ID of the Upload object that this Part was added to.

Example

curl https://api.openai.com/v1/uploads/$UPLOAD_ID/parts \
    -H 'Content-Type: multipart/form-data' \
    -H "Authorization: Bearer $OPENAI_API_KEY" \
    -F 'data=@/path/to/data'

Response

{
  "id": "id",
  "created_at": 0,
  "object": "upload.part",
  "upload_id": "upload_id"
}

Example

curl https://api.openai.com/v1/uploads/upload_abc123/parts
  -F data="aHR0cHM6Ly9hcGkub3BlbmFpLmNvbS92MS91cGxvYWRz..."

Response

{
  "id": "part_def456",
  "object": "upload.part",
  "created_at": 1719185911,
  "upload_id": "upload_abc123"
}

Domain Types

Upload Part

  • UploadPart object { id, created_at, object, upload_id }

    The upload Part represents a chunk of bytes we can add to an Upload object.

    • id: string

      The upload Part unique identifier, which can be referenced in API endpoints.

    • created_at: number

      The Unix timestamp (in seconds) for when the Part was created.

    • object: "upload.part"

      The object type, which is always upload.part.

      • "upload.part"
    • upload_id: string

      The ID of the Upload object that this Part was added to.